Set Implicit Arguments.

Require Import Basics.
Require Import Syntax.
Require Import Semantics.
Require Import LowEq.

(* See Section 6 for more information*)

Axiom LabelabilityOfUnlabeledExecution  : 
  forall Γ Γ' Σ1 Σ1' Σ2 Σ2' e uv uv',
     LowEq_Memory (Γ, Σ1) (Γ', Σ1') ->
     UEval L Γ Σ1 e (* => *) Σ2 uv ->
     UEval L Γ' Σ1' e (* => *) Σ2' uv' ->
  exists l, LowEq_UValue l uv uv'.

Axiom UnlabeledCorrectnessOfLibraryModels : 
  forall l uv uv' Γ Σ Γ' Σ' γ lv lv',
    LowEq_Memory (Γ, Σ) (Γ', Σ') ->
    LowEq_UValue l uv uv' -> 
    Relabel_UValue Γ Σ uv γ lv -> 
    Relabel_UValue Γ' Σ' uv' γ lv' ->
  LowEq_LValue lv lv'.

Axiom LabeledCorrectnessOfLibraryModels :
   forall Γ Γ' Σ1 Σ1' Σ2 Σ2' e uv uv',
     LowEq_Memory (Γ, Σ1) (Γ', Σ1') ->
     UEval L Γ Σ1 e (* => *) Σ2 uv ->
     UEval L Γ' Σ1' e (* => *) Σ2' uv' ->
     LowEq_Memory (Γ, Σ2) (Γ', Σ2').

